#include <bits/stdc++.h>
using namespace std;

int n;
long k;
long m[2005][2005];
bool p[2005][2005];
bool o[1000005];
bool o1[1000005];
long rez;

void oznaci(int a,int b,long m[][2005],long boja)
{
    if(m[a][b]==boja)
    {   p[a][b]=true;
        if(a>0&&p[a-1][b]==false)
            oznaci(a-1,b,m,boja);
        if(b>0&&p[a][b-1]==false)
            oznaci(a,b-1,m,boja);
        if(a<n-1&&p[a+1][b]==false)
            oznaci(a+1,b,m,boja);
        if(b<n-1&&p[a][b+1]==false)
            oznaci(a,b+1,m,boja);
    }
}

void pokreni(int a,int b,long m[][2005],long boja)
{
    int i1,i2,i3=1;
    int d1=1,d2=1;
    for(int i=b+1;i<n;i++)
    {   if(m[a][i]!=boja)
            break;
        else
            d1++;
    }
    for(int i=a+1;i<n;i++)
    {   for(int j=b;j<b+d1;j++)
        {   i1=0;
            i2=0;
            if(m[i][j]!=boja)
                i2=1;
            else
            {   i1=1;
                if(i2==1)
                    break;
            }
        }
        if(i1==0)
        {   i3=1;
            break;
        }
        if(i2==1&&i1==1)
        {   i3=0;
            break;
        }
        if(b+d1<n-1)
        {   if(m[i][b+d1]==boja)
            {   i3=0;
                break;
            }
        }
        d2++;
    }

    if(i3==1)
    {   for(int i=a;i<a+d2;i++)
            for(int j=b;j<b+d1;j++)
                p[i][j]=true;
        o[boja]=true;
        o1[boja]=true;
    }
    else
    {   oznaci(a,b,m,boja);
        o[boja]=false;
        o1[boja]=false;
    }
}



int main()
{
    std::ios::sync_with_stdio(false);
    cin>>n>>k;
    for(int i=0;i<n;i++)
        for(int j=0;j<n;j++)
            cin>>m[i][j];
    for(int q=0;q<n;q++)
    {   for(int w=0;w<n;w++)
        {   long boja=m[q][w];
            if(p[q][w]==false&&o[boja]==false)
                pokreni(q,w,m,boja);
            else if(p[q][w]==false&&o[boja]==true)
            {   oznaci(q,w,m,boja);
                o1[boja]=false;
            }
        }
    }
    for(int i=1;i<=k;i++)
        if(o1[i]==true)
            rez++;
    cout<<rez<<endl;
    return 0;
}